#*****************************************************************************
#
# DESCRIPTION : Example of using a single Makefile project
#               as an alernative to a recursive makefile project.
#
# AUTHOR :      Brendan Simon.
#
#*****************************************************************************


# Can be overridden at command line.  eg. "make QUIET= all"
QUIET := @


CFLAGS :=
CFLAGS += -Wall
CFLAGS += -O2

ARFLAGS :=
ARFLAGS += -cr


%.mk :
	@ echo "ERROR: can not find $@ file."
	@ exit 1


%.o : %.c
	@ echo "        CC : $@"
	$(QUIET) $(CC) $(CFLAGS) $($(@D)_cflags) $($(@)_cflags) -o $@ -c $<


%.o : %.cxx
	@ echo "        CXX : $@"
	$(QUIET) $(CXX) $(CXXFLAGS) $($(@D)_cxxflags) $($(@)_cxxflags) -o $@ -c $<


%.a :
	@ echo "        AR : $@"
	$(QUIET) $(AR) $(ARFLAGS) $($(@D)_arflags) $($(@)_arflags) $@ $^


$(EXES) :
	@ echo "        LD : $@"
	$(QUIET) $(CC) $(LDFLAGS) $($(@D)_ldflags) $($(@)_ldflags) -o $@ $^ $($(@)_libs) $($(@D)_libs)


#*****************************************************************************
# EOF
#*****************************************************************************
