#*****************************************************************************
#
# DESCRIPTION : Example of using a single Makefile project
#               as an alernative to a recursive makefile project.
#
# AUTHOR :      Brendan Simon.
#
#*****************************************************************************


#--------------------------------------------------------------------------
# NOTE: There must be a way to automagically generate the module directory.
#--------------------------------------------------------------------------
srcdir := src/goodbye

builddir := $(srcdir)



#---------
# Sources.
#---------
c_src :=
c_src += goodbye.c

objs :=
objs += $(patsubst %.cpp,%.o,$(cpp_src))
objs += $(patsubst %.c,%.o,$(c_src))
objs += $(patsubst %.cxx,%.o,$(cxx_src))

exe := goodbye

buildlibs :=
buildlibs += src/lib/libconverse.a

buildobjs := $(addprefix $(builddir)/,$(objs))
buildexe := $(addprefix $(builddir)/,$(exe))

CPP_SRC += $(addprefix $(srcdir)/,$(cpp_src))
C_SRC += $(addprefix $(srcdir)/,$(c_src))
CXX_SRC += $(addprefix $(srcdir)/,$(cxx_src))
OBJS += $(buildobjs)
EXES += $(buildexe)


#-----------------------------------------------------------------------------
# Targets.
#-----------------------------------------------------------------------------
ALL += $(buildexe)


#-----------------------------------------------------------------------------
# Dependencies.
#-----------------------------------------------------------------------------
$(buildexe) : $(buildobjs)
$(buildexe) : $(buildlibs)


#-----------------------------------------------------------------------------
# Submodules.
#-----------------------------------------------------------------------------
subdirs :=

submodules := $(addsuffix /module.mk,$(addprefix $(TOPDIR)/$(srcdir)/,$(subdirs)))
MODULES += $(submodules)
ifdef submodules
	include $(submodules)
endif


#-----------------------------------------------------------------------------
# Rules - module specific.
#-----------------------------------------------------------------------------


#*****************************************************************************
# EOF
#*****************************************************************************
