#*****************************************************************************
#
# DESCRIPTION : Example of using a single Makefile project
#               as an alernative to a recursive makefile project.
#
# AUTHOR :      Brendan Simon.
#
#*****************************************************************************


#--------------------------------------------------------------
# Determine top level directory.
# The following will work for Aegis and non Aegis projects.
# Script to find top level directory by searching for Rules.mk
#--------------------------------------------------------------
TOPDIR := $(aegis -l cd 2>/dev/null)
ifndef TOPDIR
	script := \
		topdir=$$(pwd); \
		while true; do \
			if [ -z "$$topdir" ] || [ "$$topdir" = "/" ]; then \
				exit 0; \
			fi; \
			if [ -e $$topdir/Rules.mk ]; then \
				echo $$topdir; \
				exit 0; \
			fi; \
			topdir=$$(dirname $$topdir); \
		done
	TOPDIR := $(shell $(script))
endif


#-----------------------------
# Initialise global variables.
#-----------------------------
ALL :=
INSTALL :=


#---------------------------
# Include makefile fragment.
#---------------------------
include module.mk


#-------------------
# Top level targets.
#-------------------
.PHONY : all
all :
	cd $(TOPDIR) && $(MAKE) $(ALL)


.PHONY : install
install :
	cd $(TOPDIR) && $(MAKE) $(INSTALL)


.PHONY : debug
debug :
	echo "ALL = $(ALL)"


.DEFAULT :
	cd $(TOPDIR) && $(MAKE) $@


#*****************************************************************************
# EOF
#*****************************************************************************
